--[[
Catch - v0.1
   By alexi02 - www.uzzisoft.com/psp/
]]

-- Text colour
white = Color.new(255, 255, 255)
black = Color.new(0,0,0)

-- Images needed
background = Image.load("field.png")
ball = Image.load("ball.png")
glove = Image.load("glove.png")
menu = Image.load("menu.png")
levelpic = Image.load("level.png")
about = Image.load("about.png")
uzzisoft_logo = Image.load("uzzisoft_logo.png")

-- Start location for glove
cursorx = 220

-- Menu
onmenu = 1
-- Menu Control
menuy = 100
-- Menu Time
menutime = 0

leveltime = 1
levelspeed = 1
currentlevel = 1

-- Pause
pause = 0
pausetime = 0

-- Score
score = 0

-- Timer for the enemy to go
enemytimer = 0

-- Enemy (Ball) Globals
enemy = 0
enemyx = {}
enemyy = {}
enemytime = {}
enemyactive = {}
enemyspeed = {}

function showbackground()

   screen:blit(0,0, background)

   -- Title
   screen:print(160, 1, "Catch v0.1 - By alexi02", black)

end

function level()

   score = 0
   time = 0
   enemytimer = 0

   -- Amount of enemies
   enemy = 0

   -- Timer counter
   totaltime = 20

   for a = 1,100 do
      totaltime = math.random(100) + totaltime 
      table.insert(enemyx, math.random()*460)
      table.insert(enemyy, 20)
      table.insert(enemytime, totaltime)
      table.insert(enemyactive, 0)
      table.insert(enemyspeed, 1)
      enemy = enemy + 1
   end

   screen:clear()
   showbackground()
   screen:blit(165,80, levelpic)
   screen:print(215, 85, "Level " .. currentlevel, white)
   screen:print(205, 106, "Get Ready!", white)
   screen:flip()
   screen.waitVblankStart(180)

end

function restartlevel()

   enemy = 0
   enemyx = {}
   enemyy = {}
   enemytime = {}
   enemyactive = {}
   enemyspeed = {}

   enemytimer = 20

   -- Amount of enemies
   enemy = 0

   -- Timer counter
   totaltime = 0

   levelspeed = levelspeed + 0.1
   currentlevel = currentlevel + 1

    for a = 1,100 do
      totaltime = math.random(100) + totaltime 
      table.insert(enemyx, math.random()*460)
      table.insert(enemyy, 20)
      table.insert(enemytime, totaltime)
      table.insert(enemyactive, 0)
      table.insert(enemyspeed, levelspeed)
      enemy = enemy + 1
   end

   screen:clear()
   showbackground()
   screen:blit(165,80, levelpic)
   screen:print(215, 85, "Level " .. currentlevel, white)
   screen:print(205, 106, "Get Ready!", white)
   screen:flip()
   screen.waitVblankStart(180)

end

while true do

   -- Clear Screen
   screen:clear()

   showbackground()

   -- Menu
   if onmenu == 1 then
      screen:blit(90,50, menu)
      screen:print(228, 100, "Start", white)
      screen:print(228, 110, "About", white)

      pad2 = Controls.read()

      if pad2:up() then
         if menutime == 0 then
            if menuy > 100 then
               menuy = menuy - 10
            end
            menutime = 1
         end
      end
   
      if pad2:down() then
         if menutime == 0 then
            if menuy < 110 then
               menuy = menuy + 10
            end
            menutime = 1
         end
      end

      if pad2:cross() then
         if menuy == 100 then
            onmenu = 0
            level()
         end
         if menuy == 110 then
            onmenu = 2
            screen.waitVblankStart(15)
         end
      end

      -- Timer for Menu Selecting
      if menutime >= 1 then
         menutime = menutime + 1
      end
      if menutime == 5 then
         menutime = 0
      end
      screen:print(190, menuy, "->", white)
   end

   -- Menu -> About
   if onmenu == 2 then
      screen:clear()
      showbackground()
      screen:blit(90,50, about)
      screen:print(214, 100, "2005/11/1", white)
      screen:print(210, 110, "By alexi02", white)
      screen:print(170, 120, "www.uzzisoft.com/psp/", white)
      screen:blit(105,128, uzzisoft_logo)

      pad3 = Controls.read()

      if pad3:cross() then
         onmenu = 1
         screen.waitVblankStart(15)
      end
   end

      -- Read Controls pressed and change cursor location
   pad = Controls.read()

   -- If not Paused and not in menu
   if pause == 0 and onmenu == 0 then

      if pad:left() then
         if cursorx > 0 then
            cursorx = cursorx - 5
         end
      end
   
      if pad:right() then
         if cursorx < 445 then
            cursorx = cursorx + 5
         end
      end
   
      aX = pad:analogX()
      
      if aX < -23 then
         if cursorx > 0 then
            cursorx = cursorx - 5
         end
      end
   
      if aX > 23 then
         if cursorx < 445 then
            cursorx = cursorx + 5
         end
      end 

   -- Collision Detection
   for w = 1,enemy do
      if enemyactive[w] == 1 then
         if enemyy[w] < 272 then
            enemyx2 = 19
            enemyy2 = 20
            local realenemyxleft = enemyx[w]
            local realenemyxright = enemyx[w] + enemyx2
            local realenemyytop = enemyy[w]
            local realenemyybottom = enemyy[w] + enemyy2
            if realenemyxleft > cursorx-10 and realenemyxright < cursorx+35 then
               if realenemyytop > 230 and realenemyybottom < 264 then
                  enemyy[w] = 1000
                  score = score + 1
               end
            end
         end
      end
   end

      -- Enemy Timer for activating enemies
      for t = 1,enemy do
         if enemytime[t] == enemytimer then
            enemyactive[t] = 1
         end
      end
      enemytimer = enemytimer + 1
   end

   -- If not in menu
   if onmenu == 0 then

      -- Print Score
      screen:print(1, 1, "Balls Catched " .. score, black)

      -- Glove
      screen:blit(cursorx, 230,glove)

      -- Print Enemies
      for e = 1,enemy do
         if enemyy[e] > 272 then
         elseif enemyactive[e] == 1 then
            screen:blit(enemyx[e], enemyy[e], ball)
            if pause == 0 then
               enemyy[e] = enemyy[e] + enemyspeed[e]
            end
         end      
      end    

      -- If last ball restart the balls
      if enemyy[100] > 272 then
         restartlevel()
      end
   end

   -- Print Paused if needed
   if pause == 1 then
      screen:print(220, 190, "PAUSED", black)
   end

   -- Pause Timer
   if pausetime >= 1 then
      pausetime = pausetime + 1
   end
   if pausetime == 25 then
      pausetime = 0
   end

  	screen.waitVblankStart()
	screen.flip()

   if pad:select() then
      onmenu = 1
      pause = 0
	end

	if pad:start() then
		break
	end

   if pad:l() then screen:save("screenshot4.tga") end

   -- For Pause
   if pad:circle() then 
      if onmenu == 0 then
         if pausetime == 0 then
            if pause == 0 then
               pause = 1
            elseif pause == 1 then
               pause = 0
            end
            pausetime = 1
         end
      end
   end
end